﻿Liquid_Wealth = LibStub("AceAddon-3.0"):NewAddon("Liquid-Wealth","AceEvent-3.0", "AceComm-3.0", "AceConsole-3.0", "AceSerializer-3.0"); --Declare Ace3 Addon
local LibQTip = LibStub("LibQTip-1.0") --Declare ToolTip Plugin
local ldb_obj = LibStub("LibDataBroker-1.1"):NewDataObject("Liquid_Wealth", {icon = "Interface\\Icons\\INV_Misc_Coin_02.png",label = "Liquid-Wealth",type = "data source",text = "Liquid-Wealth"}); --Declare LibDataBroker Plugin
local abacus = LibStub("LibAbacus-3.0"); --Used To Display Money
 
function Liquid_Wealth:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("Liquid_WealthDB",DATABASE_DEFAULTS,'Default')
	--Load Options Table from clsAce3ConfigCore
	Liquid_Wealth:LoadOptionsTables()
	--Set the current login toon as the currently selected toon. This will tell the tooltip to display the current toon's information.
    varCurrentPlayer = UnitName("player");
	--Call clsdatabase this checks the databased version, and to see if there is data in the database
    Liquid_Wealth:CheckMasterDatabase();
	--Calls ClsDatabase, checks to see if the current toon is in the database, and checks guild information
	Liquid_Wealth:CheckToonEntery(UnitName("player"),"local",Liquid_Wealth:genHexPSK(),UnitSex("Player"),UnitRace("Player"),UnitClass("Player"));
end


function Liquid_Wealth:OnEnable()
    self:Print("Liquid_Wealth Now Running");
    varIsBankFrameOpen = false;
	tabsNotScanned = {}
    self:RegisterEvent("BANKFRAME_OPENED");
    self:RegisterEvent("BANKFRAME_CLOSED");
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("PLAYER_GUILD_UPDATE");
    self:RegisterComm("LMAC")
	self:RegisterEvent("GUILDBANKFRAME_OPENED")
	self:RegisterEvent("GUILDBANKFRAME_CLOSED")
	Liquid_Wealth:CheckToonEntery(UnitName("player"),"local",Liquid_Wealth:genHexPSK(),UnitSex("Player"),UnitRace("Player"),UnitClass("Player"));
	if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
		ldb_obj.text="Liquid-Wealth: Guild Bank";
	else
		ldb_obj.text="Liquid-Wealth: Player";
	end
end
	
ITEM_BIND_ON_EQUIP = "Binds when equipped"; -- Item will be bound when equipped
ITEM_BIND_ON_PICKUP = "Binds when picked up"; -- Item wil be bound when picked up
ITEM_BIND_ON_USE = "Binds when used"; -- Item will be bound when used
ITEM_BIND_QUEST = "Quest Item"; -- Item is a quest item (same logic as ON_PICKUP)
ITEM_SOULBOUND = "Soulbound"; -- Item is Soulbound

--Calls LibGratuity to make tooltip and then scan though the lines to match based on item Rarity / Type / Soulbound
function Liquid_Wealth:IsItemSoulbound(bagId,slot)
	local tooltip = LibStub:GetLibrary("LibGratuity-3.0")
    local ContainerItemLink = GetContainerItemLink(bagId, slot)
    if ContainerItemLink then
        local _, _, iRarity, _, _, sType, sSubType, _, sEquipLoc = GetItemInfo(ContainerItemLink)
        tooltip:SetBagItem(bagId,slot)
        if  (iRarity >= 2) and (sType == 'Armor') or (sType == 'Weapon') and not tooltip:Find(ITEM_SOULBOUND, 1, 3 ) then
			return true
		else
			return false
        end
    end
end

function Liquid_Wealth:IsItemQuest(bagId,slot)
	local tooltip = LibStub:GetLibrary("LibGratuity-3.0")
    local ContainerItemLink = GetContainerItemLink(bagId, slot)
    if ContainerItemLink then
        local _, _, iRarity, _, _, sType, sSubType, _, sEquipLoc = GetItemInfo(ContainerItemLink)
        tooltip:SetBagItem(bagId,slot)
        if tooltip:Find(ITEM_BIND_QUEST, 1, 3 ) then
			return true
		else
			return false
        end
    end
end
	
function Liquid_Wealth:PLAYER_GUILD_UPDATE()
	Liquid_Wealth:CheckToonEntery(UnitName("player"),"local",Liquid_Wealth:genHexPSK(),UnitSex("Player"),UnitRace("Player"),UnitClass("Player"));
end

function Liquid_Wealth:GUILDBANKFRAME_CLOSED()
	if (Liquid_Wealth.db.profile.scanGuildBank) then
		if next(tabsNotScanned) then
			-- Tabs never opened cannot be scanned. And no, force looping SetGuildCurrentGuildBankTab() doesn't work either, you really do have to wait until it populates (server roundtrip). This obviously can't be done on the bank closing.
			self:Print("Guild bank tabs not scanned: "..table.concat(tabsNotScanned, ", "))
			tabsNotScanned = {}
		end
	end
end

function Liquid_Wealth:GUILDBANKFRAME_OPENED()
	if (Liquid_Wealth.db.profile.scanGuildBank) then
		local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
		if not Liquid_Wealth:CheckGuildBank(guildName) then
			Liquid_Wealth.db.realm.guild[guildName] = {}
			Liquid_Wealth:ScanGuildBank(guildName)
		else
			Liquid_Wealth:ScanGuildBank(guildName)
		end
	end	
end

function Liquid_Wealth:PLAYER_ENTERING_WORLD()
    if not InCombatLockdown() then	
		Liquid_Wealth:Scan(0,4);
    end
end

function Liquid_Wealth:BAG_UPDATE(event, bagID)
    if not InCombatLockdown() then	
        if (bagID > -1 and bagID < 5) then --Update Only The Local Bags
            Liquid_Wealth:Scan(bagID,bagID) --Tells the scan function to scan only the bags that change
        end
    end
end

function Liquid_Wealth:forceScan(command)
	if command == 1 then --Force Scan Bags
		Liquid_Wealth:Scan(0,4);
	elseif command == 2 then --Force Scan Banks
		Liquid_Wealth:Scan(-1,-1);
		Liquid_Wealth:Scan(5,11);
	else --Force Scan Using Remote Inv Addon.

	end
end

function Liquid_Wealth:Scan(startbag,endbag)
	local bagLink = ""
	local bagName = ""
	local bagTexturePath = ""
	self:Print(startbag)
	self:Print(endbag)
	if (startbag == endbag) then
		self:Print("Start Bag == End Bag")
		if (GetContainerNumSlots(startbag)>=1) and (startbag>0) then --Check to see if player had bag equipped, and to skip bank and backpack
			local invID = ContainerIDToInventoryID(startbag);
			bagLink = GetInventoryItemLink("player",invID);
			local itemName, itemLink, _, _, _, _, _, _,_, itemTexture, _ = GetItemInfo(bagLink)
			bagTexturePath = itemTexture
			bagName = itemName
		elseif startbag==-1 then --Bank
			bagLink="Bank";
			bagTexturePath="Interface\\Icons\\INV_Misc_Bag_08"
			bagName="Bank"
		elseif startbag==0 then --Backpack
			bagLink="Backpack"
			bagTexturePath="Interface\\Icons\\INV_Misc_Bag_08"
			bagName="Backpack"
		else
		    bagLink = "NONE" -- Set the Item ID to none if the player didn't buy a bank/equipped bag or bank slot.
			bagTexturePath="NONE"
			bagName="NONE"
		end 
		Liquid_Wealth.db.realm.toon[UnitName("player")].bagID[startbag] = Liquid_Wealth:ConvItemDataToDB(bagLink,bagTexturePath,bagName,Liquid_Wealth:GetBagValueVender(startbag),Liquid_Wealth:GetBagValueAuction(startbag));
	else
		self:Print("Start Bag Is Not == End Bag")	
		for bagId = startbag, endbag do -- Add up the value of each bag's contents
			if (GetContainerNumSlots(bagId)>=1) and (bagId>0) then --Check to see if player had bag equipped, and to skip bank and backpack
				local invID = ContainerIDToInventoryID(bagId);
				bagLink = GetInventoryItemLink("player",invID);
			local itemName, itemLink, _, _, _, _, _, _,_, itemTexture, _ = GetItemInfo(bagLink)
			bagTexturePath = itemTexture
			bagName = itemName
			elseif bagId==-1 then --Bank
				bagLink="Bank";
				bagTexturePath="Interface\\Icons\\INV_Misc_Bag_08"
				bagName="Bank"
			elseif bagId==0 then --Backpack
			    bagLink="Backpack";
				bagTexturePath="Interface\\Icons\\INV_Misc_Bag_08"
				bagName="Backpack"
			else
			    bagLink = "NONE" -- Set the Item ID to none if the player didn't buy a bank/equipped bag or bank slot.
				bagTexturePath="NONE"
				bagName="NONE"
			end 
			Liquid_Wealth.db.realm.toon[UnitName("player")].bagID[bagId] = Liquid_Wealth:ConvItemDataToDB(bagLink,bagTexturePath,bagName,Liquid_Wealth:GetBagValueVender(bagId),Liquid_Wealth:GetBagValueAuction(bagId));
		end
	end	
	Liquid_Wealth.db.realm.toon[UnitName("player")].playergold = GetMoney();
	Liquid_Wealth.db.realm.toon[UnitName("player")].lastChecked = date("%m/%d/%y %I:%M:%S %p");
end

function Liquid_Wealth:BANKFRAME_OPENED()
    if not InCombatLockdown() then
        varIsBankFrameOpen = true;
        Liquid_Wealth:Scan(-1,11)--Loop though all the bags and bank bags
    end
end

function Liquid_Wealth:BANKFRAME_CLOSED()
    if not InCombatLockdown() then	
        varIsBankFrameOpen = false;
    end
end

function Liquid_Wealth:CharTotal(toon)
    local VenderTotalRelam=0;
    local AuctionTotalRelam = 0;
    for bagId = -1, 11 do -- Add up the value of each bag's contents
        local _,_,_,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(bagId,toon);
        VenderTotalRelam=VenderTotalRelam+VenderTotal;
        AuctionTotalRelam=AuctionTotalRelam+AuctionTotal;
    end
    -- VenderTotal=VenderTotal+Liquid_Wealth.db.realm.toon[toon].playergold;
    -- AuctionTotal=AuctionTotal+Liquid_Wealth.db.realm.toon[toon].playergold;
    return VenderTotalRelam,AuctionTotalRelam
end

function Liquid_Wealth:ConfigToolTip()
	tip =  LibQTip:Acquire("Liquid_WealthTooltip", 3, "LEFT", "CENTER", "RIGHT")
	tip:Clear()
	tip:SetScale(1)
	tip:EnableMouse(true)
	if _G.TipTac and _G.TipTac.AddModifiedTip and Liquid_Wealth.db.profile.TipTacSkin then
		-- Pass true as second parameter because hooking OnHide causes C stack overflows
		_G.TipTac:AddModifiedTip(tip, true)

	end
	MetaDataVersion = GetAddOnMetadata("Liquid_Wealth", "Version") 
	tip:SetCell(tip:AddHeader(""), 1, "Liquid-Wealth "..MetaDataVersion, nil, "CENTER", 3)
	
	if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
		Liquid_Wealth:showGuildBankToolTip()
	else
		Liquid_Wealth:ConfigPlayerTooltip()
	end
	Liquid_Wealth:FixCellSizes(tip) --This will send the tooltip to the fixer until the Lib has been updated
end 

function Liquid_Wealth:ConfigHintTip()
	tipLWHINT = LibQTip:Acquire("Liquid_WealthTooltipHint", 1, "LEFT")
	tipLWHINT:Clear()
	tipLWHINT:SetScale(1)
	tipLWHINT:EnableMouse(true)
	if _G.TipTac and _G.TipTac.AddModifiedTip and Liquid_Wealth.db.profile.TipTacSkin then
		-- Pass true as second parameter because hooking OnHide causes C stack overflows
		_G.TipTac:AddModifiedTip(tipLWHINT, true)
	end
	tipLWHINT:SetCell(tipLWHINT:AddHeader(""),1, "Liquid-Wealth Hints", nil, "CENTER", 1)
	tipLWHINT:AddLine("|cffff8020Left Click |r on LDB plugin to change to and from Player & Guild Bank")
	tipLWHINT:AddLine("|cffff8020Right Click |r on LDB plugin to open Configuration Window")
	tipLWHINT:SetPoint("CENTER",tip, "BOTTOM", 0, -33)
    tipLWHINT:Show()
end

function Liquid_Wealth:ConfigPlayerTooltip()
	tip:SetCell(tip:AddHeader(""), 1,"Current Selected Player: "..Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[varCurrentPlayer].unitID).." "..varCurrentPlayer,nil,"CENTER", 3)
	modeHeader=tip:AddHeader("")
	--tip:SetCell(modeHeader, 1,"Player", nil, "CENTER")
	if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
		tip:SetCell(modeHeader, 1, "Value Mode: Vender",nil,"CENTER",3)
	else
		tip:SetCell(modeHeader, 1, "Value Mode: Auction",nil,"CENTER",3)
	end
	tip:SetCellScript(modeHeader,1, "OnMouseDown", function() Liquid_Wealth:ChangeViewModes() end);
	
	header=tip:AddHeader("")
	tip:SetCell(header, 1, format("|TInterface\\Buttons\\UI-%sButton-Up:18:18:1:0|t".." Player Bags", Liquid_Wealth.db.profile.noBagInfoTip and "Plus" or "Minus"))
	tip:SetCellScript(header, 1, "OnMouseDown", function() 
		Liquid_Wealth.db.profile.noBagInfoTip = not Liquid_Wealth.db.profile.noBagInfoTip 
		Liquid_Wealth:ToolTipUpDate() 
		end)
	tip:SetCell(header, 3,"Value")
	
	local playerDetail = tip:AddLine("")
  if (Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagId==nil) and (Liquid_Wealth.db.realm.toon[varCurrentPlayer].lastChecked==0) then
    tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Backpack").." Backpack" , nil , "LEFT"  , 1)
	tip:SetCell(playerDetail, 2,"Sorry No Data Yet, Please Vist Bank Now",nil, "CENTER"  , 2)
  else
   if Liquid_Wealth.db.profile.noBagInfoTip then
        local VenderTotalToon=0;
        local AuctionTotalToon=0;
        for bagId = 0, 4 do -- Add up the value of each bag's contents
            _,_,_,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(bagId,varCurrentPlayer)
            VenderTotalToon=VenderTotalToon+VenderTotal
            AuctionTotalToon=AuctionTotalToon+AuctionTotal
        end
       
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Backpack").." Backpack's" , nil , "LEFT"  , 1)
		if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotalToon,true),nil, "RIGHT"  , 1)
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotalToon,true),nil, "RIGHT"  , 1)
		end
   else
        local BagItemLink,BagIconPath,BagName,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(0,varCurrentPlayer)
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Backpack").." Backpack" , nil , "LEFT"  , 1)
        if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
		end

        for bagId = 1, 4 do -- Add up the value of each bag's contents
            local BagItemLink,BagIconPath,BagName,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(bagId,varCurrentPlayer)
            local playerDetail = tip:AddLine("")
			if BagItemLink == "NOSCAN" then
				tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("NONE") , nil , "LEFT"  , 1)
				tip:SetCell(playerDetail, 2,"Sorry No Data Yet, Please Vist Bank Now",nil, "CENTER"  , 2)
            elseif (BagItemLink=="NONE") then    
                tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink).." Not Equipped",nil, "LEFT"  , 1)
				if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
				else
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)  
				end    
            else
                tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink,BagIconPath).." "..BagName,nil, "LEFT"  , 1)
				if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
				else
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)  
				end  
            end
        end
   end
    
  end  
  tip:AddLine(" ")
  header=tip:AddHeader("")
  tip:SetCell(header, 1, format("|TInterface\\Buttons\\UI-%sButton-Up:18:18:1:0|t".." Bank Bags", Liquid_Wealth.db.profile.noBankInfoTip and "Plus" or "Minus"))
  tip:SetCellScript(header, 1, "OnMouseDown", function() 
	Liquid_Wealth.db.profile.noBankInfoTip = not Liquid_Wealth.db.profile.noBankInfoTip 
	Liquid_Wealth:ToolTipUpDate() 
	end)
  tip:SetCell(header, 3,"Value")
  local playerDetail = tip:AddLine("")
  if ((not Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID) and (Liquid_Wealth.db.realm.toon[varCurrentPlayer].lastChecked==0)) or (not Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID[-1]) then
    tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Bank").." Bank", nil , "LEFT"  , 1)
    tip:SetCell(playerDetail, 2,"Sorry No Data Yet, Please Scan Now",nil, "CENTER"  , 2)
  else
    if Liquid_Wealth.db.profile.noBankInfoTip then
        local VenderTotal=0;
        local AuctionTotal=0;
        for bagId = 5, 11 do -- Add up the value of each bag's contents
            _,_,_,Vender,Auction=Liquid_Wealth:ConvItemDataFromDB(bagId,varCurrentPlayer)
            VenderTotal=VenderTotal+Vender
            AuctionTotal=AuctionTotal+Auction
        end
        _,_,_,Vender,Auction=Liquid_Wealth:ConvItemDataFromDB(-1,varCurrentPlayer)
        VenderTotal=VenderTotal+Vender
        AuctionTotal=AuctionTotal+Auction
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Bank").." Bank's" , nil , "LEFT"  , 1)
		if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
		end
        
    else
        local BagItemLink,BagIconPath,BagName,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(-1,varCurrentPlayer)
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Bank").." Bank" , nil , "LEFT"  , 1)
		if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
		end
        
        for bagId = 5, 11 do -- Add up the value of each bag's contents
            local BagItemLink,BagIconPath,BagName,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(bagId,varCurrentPlayer)
            local playerDetail = tip:AddLine("")
            if (BagItemLink=="NONE") then
                tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink).." Not Equipped",nil, "LEFT"  , 1)
				if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
				    tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
				else
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)  
				end
            else
                tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink,BagIconPath).." "..BagName,nil, "LEFT"  , 1)
				if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
				else
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
				end    
            end
        end
    end
  end
  tip:AddLine(" ");
  local Header = tip:AddLine("");
  tip:SetCell(Header, 1, "|cffeda55fCharacter|r", nil, "LEFT"  , 1)
  tip:SetCell(Header, 2, "|cffeda55fScan Date|r", nil, "CENTER", 1) 
  if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
	tip:SetCell(Header, 3, "|cffeda55fTotal [Vender]|r", nil, "RIGHT", 1)  
  else
	tip:SetCell(Header, 3, "|cffeda55fTotal [Acution]|r", nil, "RIGHT", 1)  
  end  
  
  --Sorted List Goes Here
  Liquid_Wealth:returnSortedCharListed(tip)
end

function Liquid_Wealth:returnSortedCharListed(tip)
  local relamTotalVender=0;
  local relamTotalAuct=0;
  --Loop though all the toons stored in the database
  for chars in pairs(self.db.realm.toon) do
    local playerDetail = tip:AddLine("");
	--If there is no data for the current login toon display "Scan Now Message" and Build Sex & Race Icons
    if (Liquid_Wealth.db.realm.toon[chars].bagId==nil) and (Liquid_Wealth.db.realm.toon[chars].lastChecked==0) then
		tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[chars].unitID).." "..chars,nil, "LEFT"  , 1);
        tip:SetCell(playerDetail, 2, "Sorry No Data Yet, Please Scan Now",nil, "CENTER"  , 2);       
    else
		--Set the linescript to change the currently viewed toon to the selected. Build the Race & Sex Icons, and then add up the current total for the toon.
        local vend,auct = Liquid_Wealth:CharTotal(chars);
		tip:SetLineScript(playerDetail, "OnMouseDown", function() Liquid_Wealth:ViewPlayer(chars) end);
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[chars].unitID).." "..chars,nil, "LEFT"  , 1);
        tip:SetCell(playerDetail, 2,Liquid_Wealth.db.realm.toon[chars].lastChecked,nil, "CENTER" , 1);
		if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(vend,true),nil, "RIGHT"  , 1);
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(auct,true),nil, "RIGHT"  , 1);
		end  
        relamTotalVender=relamTotalVender+vend;
        relamTotalAuct=relamTotalAuct+auct;
    end
	--Adds a nice yellow line to who is the currently selected player in the tooltip
	if chars == varCurrentPlayer then
		tip:SetLineColor(playerDetail,255,255)
	end
  end
  --Calculate the total for the current relam
  local relamDetail = tip:AddLine("");
  tip:SetCell(relamDetail, 1, "Total Amount On Relam:",nil, "LEFT"  , 1);
  if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
	tip:SetCell(relamDetail, 2,abacus:FormatMoneyFull(relamTotalVender,true),nil, "RIGHT"  , 2);  
  else
	tip:SetCell(relamDetail, 2,abacus:FormatMoneyFull(relamTotalAuct,true),nil, "RIGHT"  , 2);  
  end 
  
end

function Liquid_Wealth:ToolTipUpDate()
	Liquid_Wealth:ConfigToolTip()
	tip:Show();
end

function Liquid_Wealth:ChangeViewModes()
	if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
		Liquid_Wealth.db.profile.gdisplayMode="Auction"
	else
		Liquid_Wealth.db.profile.gdisplayMode="Vender"
	end
	Liquid_Wealth:ConfigToolTip()
	tip:Show();
end

function Liquid_Wealth:ViewPlayer(Toon)
	varCurrentPlayer=Toon;
	Liquid_Wealth:ConfigToolTip()
	tip:Show();
end

function HideTooltipLW()
	if MouseIsOver(tip) then return end
		tip:SetScript('OnLeave', nil)
	if Liquid_Wealth.db.profile.displayHints then
		HideToolTipHint() -- This should hide the hint tooltip when we move our mouse away from the LW tooltip.
	end
	tooltipIsShown = false
	tip=LibQTip:Release(tip)
end

function HideToolTipHint()
	if MouseIsOver(tip) then return end
	tipLWHINT:SetScript('OnLeave', nil)
	tipLWHINT=LibQTip:Release(tipLWHINT)
end

function ldb_obj.OnLeave(self)
  if MouseIsOver(tip) then
    tip:SetScript('OnLeave', HideTooltipLW)
  else
    HideTooltipLW()
  end
end

function ldb_obj.OnEnter(self) --When you hover over ldb plugin show LW Tooltip
	Liquid_Wealth:ConfigToolTip()
	if Liquid_Wealth.db.profile.displayHints then
		Liquid_Wealth:ConfigHintTip()
	end
    tip:SmartAnchorTo(self)
    tip:Show()
end

function ldb_obj.OnClick(self, button) --When Clicking on the ldb plugin do some functions
	if button == "RightButton" then		
		InterfaceOptionsFrame_OpenToCategory("LiquidWealth");
	else
		if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
			Liquid_Wealth.db.profile.displayMode = "Player";
			ldb_obj.text="Liquid-Wealth: Player";
		else
			Liquid_Wealth.db.profile.displayMode = "GuildBank";
			ldb_obj.text="Liquid-Wealth: Guild Bank";
		end
		Liquid_Wealth:ConfigToolTip()
		if Liquid_Wealth.db.profile.displayHints then
			Liquid_Wealth:ConfigHintTip()
		end
		tip:SmartAnchorTo(self)
		tip:Show()
	end
end
